// username
var user;

// session ulozene v sessionStorage
if (sessionStorage.tabID) {
  // vytvoreni noveho ID pokud nove okno vzniklo jako duplikat
  if (window.name != "webTerm") {
    sessionStorage.tabID = make_id();
    window.name = "webTerm";
  }
} else {
  sessionStorage.tabID = make_id();
  window.name = "webTerm";
}
var session_id = sessionStorage.tabID;

// enum se stavy zpracovani odpovedi
var s = 0;
var State = {normal: s++, escaped: s++, csi: s++, osc: s++, dcs: s++, charset: s++, ignore: s++};

// rozmery okna terminalu
var cols;
var rows;

// rozmery jednoho znaku
var char_size;

// tabulka kodu 256 barev
var color_table = [];
// https://upload.wikimedia.org/wikipedia/commons/1/15/Xterm_256color_chart.svg
// 16 zakladnich barev
color_table.push("#000000"); // 0
color_table.push("#800000"); // 1
color_table.push("#008000"); // 2
color_table.push("#808000"); // 3
color_table.push("#000080"); // 4
color_table.push("#800080"); // 5
color_table.push("#008080"); // 6
color_table.push("#C0C0C0"); // 7
color_table.push("#808080"); // 8
color_table.push("#FF0000"); // 9
color_table.push("#00FF00"); // 10
color_table.push("#FFFF00"); // 11
color_table.push("#0000FF"); // 12
color_table.push("#FF00FF"); // 13
color_table.push("#00FFFF"); // 14
color_table.push("#FFFFFF"); // 15

// generovani barev 16 - 231
var color_parts = ["00", "5F", "87", "AF", "D7", "FF"];

for (var i = 0; i < 216; i++) {
  if (i == 162) {
    // "D7" -> "DF"
    color_parts[4] = "DF";
  }
  k = Math.floor(i / 36);
  j = Math.floor((i % 36) / 6);
  color_table.push("#" + color_parts[k] + color_parts[j] + color_parts[i % 6]);
}

// barvy 232 - 255
color_table.push("#080808"); // 232
color_table.push("#121212"); // 233
color_table.push("#1C1C1C"); // 234
color_table.push("#262626"); // 235
color_table.push("#303030"); // 236
color_table.push("#3A3A3A"); // 237
color_table.push("#444444"); // 238
color_table.push("#4E4E4E"); // 239
color_table.push("#585858"); // 240
color_table.push("#626262"); // 241
color_table.push("#6C6C6C"); // 242
color_table.push("#767676"); // 243
color_table.push("#808080"); // 244
color_table.push("#8A8A8A"); // 245
color_table.push("#949494"); // 246
color_table.push("#9E9E9E"); // 247
color_table.push("#A8A8A8"); // 248
color_table.push("#B2B2B2"); // 249
color_table.push("#BCBCBC"); // 250
color_table.push("#C6C6C6"); // 251
color_table.push("#D0D0D0"); // 252
color_table.push("#DADADA"); // 253
color_table.push("#E4E4E4"); // 254
color_table.push("#EEEEEE"); // 255

// uloziste pro zvolene atributy znaku
var attr;
// barva popredi
var fg_color;
// barva pozadi
var bg_color;
// tucne pismo
var bold = false;
// kurziva
var italic = false;
// atributy kurzoru
var cursor_attr = "background-color: " + color_table[2] + ";";
// zobrazit kurzor
var show_cursor = true;
// mod kurzoru
var application_cursor = false;
// mod numericke klavesnice
var application_keypad = false;
// vkladaci mod
var insert_mode = false;
// obalka
var autowrap_mode = true;
// uloziste pro zalohu pozice kurzoru
var saved_cursor = {x : 0, y : 0};
// znakova sada
var g_charset = null;
var g_level = 0;
var charset;
var charsets = [null];
// horni a dolni ohraniceni oblasti pro scrolling
var top_margin;
var bottom_margin;
// ohranicujici div s posuvnikem
var div_wrapper;

var idle_timer;
var requests = [];
var conn_pending = false;

// standartni screen
var std_buf = {lines: [],
               screen: null,
               screen_body: null,
               screen_row: [],
               x: 0,
               y: 0,
               shift: 0,
               refresh_from: 0,
               alt: false};

// alternativni screen(pro okenni aplikace)
var alt_buf = {lines: [],
               screen: null,
               screen_body: null,
               screen_row: [],
               x: 0,
               y: 0,
               shift: 0,
               refresh_from: 0,
               alt: true};

// zvoleny buffer
buf = std_buf;

// znakove sady
var charset_table = {
  spec_char_and_line_draw: {
    "`": "\u25c6",
    a: "\u2592",
    b: "\t",
    c: "\f",
    d: "\r",
    e: "\n",
    f: "\u00b0",
    g: "\u00b1",
    h: "\u2424",
    i: "\x0b",
    j: "\u2518",
    k: "\u2510",
    l: "\u250c",
    m: "\u2514",
    n: "\u253c",
    o: "\u23ba",
    p: "\u23bb",
    q: "\u2500",
    r: "\u23bc",
    s: "\u23bd",
    t: "\u251c",
    u: "\u2524",
    v: "\u2534",
    w: "\u252c",
    x: "\u2502",
    y: "\u2264",
    z: "\u2265",
    "{": "\u03c0",
    "|": "\u2260",
    "}": "\u00a3",
    "~": "\u00b7"
  },
  united_kingdom: null,
  united_states: null,
  dutch: null,
  finnish: null,
  french: null,
  french_canadian: null,
  german: null,
  italian: null,
  norwegian_danish: null,
  spanish: null,
  swedish: null,
  swiss: null,
  iso_latin: null
};

// prepinani mezi G0 - G3
function set_gx_level(level)
{
  g_level = level;
  charset = charsets[level];
}

// prirazeni znakovych sad do G0 - G3
function set_gx_charset(g, new_charset)
{
  charsets[g] = new_charset;
  if (g_level == g) {
    charset = new_charset;
  }
}

// ziskani atributu
function get_attr(bg_color, fg_color, bold, italic)
{
  var attr = "";

  // barva pozadi
  attr += "background-color: " + bg_color + ";";
  // barva popredi
  attr += "color: " + fg_color + ";";

  if (bold) {
    // tucne
    attr += "font-weight: bold;";
  }

  if (italic) {
    // kurziva
    attr += "font-style: italic;";
  }

  return attr;
}

// vraci vychozi atributy s posledni pouzitou barvou pozadi
function get_erase_attr()
{
  return get_attr(bg_color, color_table[7], 0);
}

// vraci vychozi atributy
function get_default_attr()
{
  return get_attr(color_table[0], color_table[7], 0);
}

// vrati jeden znak s vychozimi atributy
function get_empty_char(def_bg_col)
{
  return {char : " ", attr : def_bg_col ? get_default_attr() : get_erase_attr()};
}

// vrati jednu radku s vychozimi atributy
function get_empty_line(def_bg_col)
{
  var i;
  var chars = [];

  for (i = 0; i < cols; i++) {
    chars.push(get_empty_char(def_bg_col));
  }

  return chars;
}

// vygeneruje prazdnou obrazovku
function buf_init(buf)
{
  var i, row;

  // vytvoreni obrazovky prazdnych radku
  for (var i = 0; i < rows; i++) {
    buf.lines.push({chars : get_empty_line(true)});
  }
  // kurzor na zacatek
  buf.x = 0;
  buf.y = 0;
  buf.shift = 0;

  // vytvoreni tabulky DIVu
  buf.screen = document.createElement('div');
  buf.screen.className = "divTable";

  buf.screen_body = document.createElement('div');
  buf.screen_body.className = "divTableBody";
  buf.screen.appendChild(buf.screen_body);

  for (i = 0; i < rows; i++) {
    buf.screen_row[i] = document.createElement('div');
    buf.screen_row[i].className = "divTableRow";
    buf.screen_row[i].innerText = "";
    buf.screen_body.appendChild(buf.screen_row[i]);
  }
}

// generovani nahodneho id
function make_id() {
  var text = "";
  var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

  for (var i = 0; i < 20; i++) {
    text += possible.charAt(Math.floor(Math.random() * possible.length));
  }
  return text;
}

// zarazeni prikazu a dat do fronty
function send_cmd(_cmd, _data)
{
  if (_data.length > 0) {
    // data maji prednost pres pollem
    for (var i = 0; i < requests.length; i++) {
      if (requests[i].data.length == 0) {
        requests.splice(i, 0, {cmd: _cmd, data: _data});
        return;
      }
    }
  }
  requests.push({cmd: _cmd, data: _data});
}

// odesilani prikazu a dat z fronty
function poll_requests()
{
  while (requests.length > 0 && conn_pending == false) {
    clearTimeout(idle_timer);
    var _timeout = 1000;

    // nove spojeni
    var conn = new XMLHttpRequest();

    // nastaveni obsluhy pro zpracovani odpovedi
    conn.onreadystatechange = function() {
      if (conn.readyState === 4) {
        conn_pending = false;
        if (conn.status === 200) {
          // prenos byl uspesny
          if (conn.responseText.length) {
            var data = JSON.parse(conn.responseText);
            if (data.answer.length) {
              // zpracovat odpoved
              print(data.answer);
              _timeout = 100;
            }
          }
        } else {
          console.log("trasfer has failed (code " + conn.status + ")");
        }
        idle_timer = setTimeout(function() {
          send_cmd("wterm", "");
        }, _timeout);
      }
    }

    // otevreni spojeni
    conn.open("POST", "transfer.cgi", true);
    conn_pending = true;

    // odeslani JSON hlavicky
    conn.setRequestHeader("Content-Type", "application/json;charset=UTF-8");

    if (requests[0].cmd == "wterm") {
      var data = "";

      while (requests.length > 0 && requests[0].cmd == "wterm") {
        var request = requests.shift();
        data += request.data;
      }

      // url encoding zlych znaku
      data = data.replace(/%/g, "%25");
      data = data.replace(/\+/g, "%2B");
      data = data.replace(/&/g, "%26");

      // odeslani pozadavku
      conn.send("request=" + JSON.stringify({ "user": user, "session_id": session_id, "cmd": "wterm", "data": data }));
    } else {
      var request = requests.shift();
      // odeslani pozadavku
      conn.send("request=" + JSON.stringify({ "user": user, "session_id": session_id, "cmd": request.cmd, "data": request.data }));
    }
  }

  setTimeout(function () {
    poll_requests();
  }, 0);
}


// pozice kurzoru na radku
function cursor_char_absolute(buf, params)
{
  var param;

  param = params[0];
  if (param < 1) {
    param = 1;
  }
  buf.x = param - 1;
}

// pozice kurzoru radek + sloupec
function cursor_pos(buf, params)
{
  var col, row;

  row = params[0] - 1;
  if (params.length >= 2) {
    col = params[1] - 1;
  } else {
    col = 0;
  }

  if (row < 0) {
    row = 0;
  } else {
    if (row >= rows) {
      row = rows - 1;
    }
  }

  if (col < 0) {
    col = 0;
  } else {
    if (col >= cols) {
      col = cols - 1;
    }
  }

  buf.x = col;
  buf.y = row;
}

// pozun kurzoru nahoru
function cursor_up(buf, params)
{
  var shift = params[0];

  if (params[0] < 1) {
    shift = 1;
  }

  buf.y -= shift;
  if (buf.y < 0) {
    buf.y = 0;
    return;
  }
}

// posun kurzoru dolu
function cursor_down(buf, params)
{
  var shift = params[0];

  if (params[0] < 1) {
    shift = 1;
  }

  buf.y += shift;
  if (buf.y >= rows) {
    buf.y = rows - 1;
    return;
  }
}

// posun kurzoru doprava
function cursor_forward(buf, params)
{
  var shift = params[0];

  if (params[0] < 1) {
    shift = 1;
  }

  buf.x += shift;
  if (buf.x >= cols) {
    buf.x = cols - 1;
    return;
  }
}

// posun kurzoru doleva
function cursor_backward(buf, params)
{
  var shift = params[0];

  if (params[0] < 1) {
    shift = 1;
  }

  buf.x -= shift;
  if (buf.x < 0) {
    buf.x = 0;
    return;
  }
}

// zaloha pozice kurzoru
function save_cursor(buf, params)
{
  saved_cursor.x = buf.x;
  saved_cursor.y = buf.y;
}

// obnoveni pozice kurzoru
function restore_cursor(buf, params)
{
  buf.x = saved_cursor.x;
  buf.y = saved_cursor.y;
}

// vlozeni radku
function insert_line(buf, params)
{
  var param;

  param = params[0];

  if (param < 1) {
    param = 1;
  }
  while (param--) {
    buf.lines.splice(buf.y + buf.shift, 0, {chars : get_empty_line(false)});
    buf.lines.splice(bottom_margin + buf.shift + 1, 1);
  }
}

// smazani radku
function delete_line(buf, params)
{
  var param;

  param = params[0];
  if (param < 1) {
    param = 1;
  }
  while (param--) {
    buf.lines.splice(bottom_margin + buf.shift + 1, 0, {chars : get_empty_line(false)});
    buf.lines.splice(buf.y + buf.shift, 1);
  }
}

// smazani znaku
function delete_character(buf, params)
{
  var param;

  param = params[0];
  if (param < 1) {
    param = 1;
  }

  while (param--) {
    buf.lines[buf.y + buf.shift].chars.splice(buf.x, 1);
    buf.lines[buf.y + buf.shift].chars.push(get_empty_char(false));
  }
}

// posun dolu
function scroll_down(params)
{
  var param;

  param = params[0] || 1;
  while (param--) {
    buf.lines.splice(bottom_margin, 1);
    buf.lines.splice(top_margin, 0, get_empty_line(false));
  }
}

// smazani radku od pozice kurzoru do konce radku
function erase_chars(buf, params)
{
  var param, i;

  param = params[0];
  if (param < 1) {
    param = 1;
  }

  i = buf.x;

  while (param-- && i < cols) {
    buf.lines[buf.y + buf.shift].chars[i++] = get_empty_char(false);
  }
}

// odeslani atributu
function send_device_attributes(prefix, params)
{
  if (params[0] > 0) {
    return;
  }

  if (prefix.length == 0) {
    // primary DA
    send_cmd("wterm", "\x1b[?1;2c");
    return;
  }

  if (prefix == ">") {
    // secondary DA
    send_cmd("wterm", "\x1b[>0;276;0c");
  }
}

// posun kurzoru na radek
function line_pos_absolute(buf, params)
{
  var param;

  param = params[0];
  if (param < 1) {
    param = 1;
  }
  buf.y = param - 1;
  if (buf.y >= rows) {
    buf.y = rows - 1;
  }
}

// mazani od kurzoru doprava
function erase_right(buf, x, y)
{
  while (x < cols) {
    buf.lines[buf.shift + y].chars[x].char = " ";
    buf.lines[buf.shift + y].chars[x++].attr = get_erase_attr();
  }
}

// mazani od kurzoru doleva
function erase_left(buf, x, y)
{
  while (x--) {
    buf.lines[buf.shift + y].chars[x].char = " ";
    buf.lines[buf.shift + y].chars[x].attr = get_erase_attr();
  }
}

// mazani cele radky
function erase_line(buf, y)
{
  erase_right(buf, 0, y)
}

// mazani v obrazovce
function erase_in_display(buf, params)
{
  var j;

  switch (params[0]) {
    case 0:
      erase_right(buf, buf.x, buf.y);
      j = buf.y + 1;
      while (j < rows) {
        erase_line(buf, j++);
      }
      break;
    case 1:
      erase_left(buf, buf.x, buf.y);
      j = buf.y - 1;
      while (j--) {
        erase_line(buf, j);
      }
      break;
    case 2:
      j = rows - 1;
      while (j--) {
        erase_line(buf, j);
      }
      break;
  }
}

// mazani na radce
function erase_in_line(buf, params) {
  switch (params[0]) {
    case 0:
      erase_right(buf, buf.x, buf.y);
      break;
    case 1:
      erase_left(buf, buf.x, buf.y);
      break;
    case 2:
      erase_line(buf, buf.y);
      break;
  }
}

// nastaveni hranic pro scrollovani
function set_scroll_region(buf, prefix, params) {
  if (prefix.length > 0) {
    return;
  }
  top_margin = (params[0] || 1) - 1;
  bottom_margin = (params[1] || rows) - 1;
  buf.x = 0;
  buf.y = 0;
}

// scrollovani posuvnikem
function scroll_display(scroll)
{
  if (scroll == null) {
    div_wrapper.scrollTop = div_wrapper.scrollHeight - div_wrapper.clientHeight;
    return;
  }

  div_wrapper.scrollTop += scroll * char_size.height;
}

// posun obsahu mezi hranicemi dolu
function scroll(buf)
{
  if (buf.alt || top_margin != 0 || bottom_margin != (rows - 1)) {
    buf.lines.splice(bottom_margin + buf.shift + 1, 0, {chars : get_empty_line(false)});
    buf.lines.splice(top_margin + buf.shift, 1);
  } else {
    buf.lines.push({chars : get_empty_line(cols, false)});
    buf.shift++;
  }
}

// posun obsahu mezi hranicemi nahoru
function unscroll(buf)
{
  buf.lines.splice(top_margin + buf.shift, 0, {chars : get_empty_line(false)});
  buf.lines.splice(bottom_margin + buf.shift + 1, 1);
}

// prechod na dalsi radek
function next_line(buf)
{
  if (buf.y == bottom_margin) {
    scroll(buf);
    return;
  }
  buf.y++;
}

// prechod na predchozi radek
function previous_line(buf)
{
  if (buf.y == top_margin) {
    unscroll(buf);
    return;
  }
  buf.y--;
}

// index
function index(buf)
{
  next_line(buf);
}

// reverse index
function reverse_index(buf)
{
  previous_line(buf);
}

// nastaveni parametru
function set_mode(prefix, params) {
  var i, l;

  if (prefix.length == 0) {
    if (params == 4) {
      insert_mode = true;
    }
  }

  if (prefix == "?") {
    switch (params[0]) {
      case 1:
        application_cursor = true;
        break;
      case 2:
        set_gx_charset(0, charset_table.united_states);
        set_gx_charset(1, charset_table.united_states);
        set_gx_charset(2, charset_table.united_states);
        set_gx_charset(3, charset_table.united_states);
        break;
      case 7:
        autowrap_mode = true;
        break;
      case 12:
        console.log("TODO start blinking cursor");
        break;
      case 25:
        show_cursor = true;
        break;
      case 66:
        application_keypad = true;
        break;
      case 1049:
        console.log("TODO clear alt buf");
      case 47:
      case 1047:
        div_wrapper.removeChild(buf.screen);
        buf = alt_buf;
        div_wrapper.appendChild(buf.screen);
        break;

    }
  }
}

// obnoveni parametru
function reset_mode(prefix, params) {
  var i, l;

  if (prefix.length == 0) {
    if (params == 4) {
      insert_mode = false;
    }
  }

  if (prefix == "?") {
    switch (params[0]) {
      case 1:
        application_cursor = false;
        break;
      case 7:
        autowrap_mode = false;
        break;
      case 12:
        console.log("TODO stop blinking cursor");
        break;
      case 25:
        show_cursor = false;
        break;
      case 66:
        application_keypad = false;
        break;
      case 1049:
      case 47:
      case 1047:
        div_wrapper.removeChild(buf.screen);
        buf = std_buf;
        div_wrapper.appendChild(buf.screen);
        break;
    }
  }
}

// nastaveni atributu znaku
function char_attributes(params) {
  var i, l, p, temp;

  if ((params.length == 1) && (params[0] == 0)) {
    bg_color = color_table[0];
    fg_color = color_table[7];
    bold = false;
    italic = false;
    attr = get_attr(bg_color, fg_color, bold, italic);
    return;
  }

  l = params.length;
  i = 0;

  while (i < l) {
    p = params[i];
    if ((p >= 30) && (p <= 37)) {
      fg_color = color_table[p - 30];
    } else if ((p >= 40) && (p <= 47)) {
      bg_color = color_table[p - 40];
    } else if ((p >= 90) && (p <= 97)) {
      p += 8;
      fg_color = color_table[p - 90];
    } else if ((p >= 100) && (p <= 107)) {
      p += 8;
      bg_color = color_table[p - 100];
    } else if (p == 0) {
      bg_color = color_table[0];
      fg_color = color_table[7];
      bold = false;
      italic = false;
    } else if (p == 1) {
      bold = true;
    } else if (p == 3) {
      italic = true;
    } else if (p == 7) {
      temp = bg_color;
      bg_color = fg_color;
      fg_color = temp;
    } else if (p == 23) {
      italic = false;
    } else if (p == 39) {
      fg_color = color_table[7];
    } else if (p == 49) {
      bg_color = color_table[0];
    } else if (p == 38) {
      if (params[i + 1] == 2) {
        // barva popredi v RGB Pr/Pg/Pb
        i += 2;
        fg_color = "#" + params[i].toString(16) + params[i + 1].toString(16) + params[i + 2].toString(16);
        i += 2;
      } else if (params[i + 1] == 5) {
        // barva popredi z tabulky
        i += 2;
        fg_color = color_table[params[i] & 0xff];
      }
    } else if (p == 48) {
      if (params[i + 1] == 2) {
        // barva pozadi v RGB Pr/Pg/Pb
        i += 2;
        bg_color = "#" + params[i].toString(16) + params[i + 1].toString(16) + params[i + 2].toString(16);
        i += 2;
      } else if (params[i + 1] == 5) {
        // barva pozadi z tabulky
        i += 2;
        bg_color = color_table[params[i] & 0xff];
      }
    } else {
      console.log("TODO fix unknown char attr params " + params);
    }

    i++;
  }
  attr = get_attr(bg_color, fg_color, bold, italic);
}

// vraceni stavu terminalu
function device_status(buf, prefix, params)
{
  if (prefix.length == 0) {
    switch (params[0]) {
      case "5":
        send_cmd("wterm", "\x1b[0n"); // OK
        break;
      case "6":
        send_cmd("wterm", "\x1b[" + (buf.y + 1) + ";" + (buf.x + 1) + "R"); // ESC[r,cR
        break;
    }
  } else if (prefix == "?") {
    if (params[0] == 6) {
      send_cmd("wterm", "\x1b[" + (buf.y + 1) + ";" + (buf.x + 1) + "R"); // ESC[r,cR
    } else {
      console.log("TODO handle device status " + params[0]);
    }
  }
}

// zmena titulku okna
function set_title(title)
{
  //document.getElementById("title").innerHTML = title;
}

// prekresleni viditelne casti
function refresh_screen () {
  var last_attr;
  var line;
  var span;

  // alternativni obrazovka ma pevny pocet radku
  if (buf.alt == false) {
    // vytvoreni chybejiciho poctu DIVu(radku)
    while (buf.lines.length > buf.screen_body.childElementCount) {
      var row = document.createElement('div');
      row.className = "divTableRow";
      row.innerText = "";
      buf.screen_row.push(row);
      buf.screen_body.appendChild(buf.screen_row.slice(-1)[0]);
    }

    // zahozeni nejstarsich radku po dosazeni maximalniho poctu radku
    while (buf.lines.length > 20000) {
      buf.lines.splice(0, 1);
      buf.screen_body.removeChild(buf.screen_row[0]);
      buf.screen_row.splice(0, 1);
      buf.shift--;
    }
  }

  // prekresleni viditelne casti
  for (var i = buf.refresh_from; i < buf.lines.length; i++) {
    last_attr = get_default_attr();
    line = "<span style=\"" + last_attr + "\">";
    span = false;
    for (var j = 0; j < cols; j++) {
      if (last_attr != buf.lines[i].chars[j].attr) {
        if (span) {
          line += "</span>";
          span = false;
        }
        if (buf.lines[i].chars[j].attr != get_default_attr()) {
          line = line + "<span style=\"" + buf.lines[i].chars[j].attr + "\">";
          span = true;
        }
        last_attr = buf.lines[i].chars[j].attr;
      }

      if (i == (buf.y + buf.shift) && j == buf.x && show_cursor) {
        line += "<span style=\"" + cursor_attr + "\">";
      }

      switch (buf.lines[i].chars[j].char) {
        case "<":
          line += "&lt;";
          break;
        case ">":
          line += "&gt;";
          break;
        case "&":
          line += "&amp;";
          break;
        case " ":
          line += "&nbsp;";
          break;
        default:
          // vyfiltrovani nekterych pretekajicich znaku (nejproblematictejsi 65533 = <?>)
          if (buf.lines[i].chars[j].char.charCodeAt() > 16383) { 
            line += "?";
          } else {
            line += buf.lines[i].chars[j].char;
          }
          
      }

      if (i == (buf.y + buf.shift) && j == buf.x && show_cursor) {
        line += "</span>";
      }
    }
    if (span) {
      line += "</span>";
    }
    line += "</span>";
    buf.screen_row[i].innerHTML = line;
  }
}

// parsovani odpovedi
function print(text)
{
  var len = text.length;
  var i = 0;
  var state = State.normal;
  var ch;
  var params;
  var param;
  var prefix;

  // ulozeni pozice odkud se bude prekreslovat
  buf.refresh_from = buf.shift;
  // pres vsechny znaky
  while (i < len) {
    ch = text.charAt(i);
    switch (state) {
      case State.normal:
        switch(ch) {
          case "\x07":
            console.log("TODO: bell");
            break;
          case "\n":
          case "\x0b":
          case "\x0c":
            next_line(buf);
            break;
          case "\r":
            buf.x = 0;
            break;
          case "\b":
            if (buf.x) {
              buf.x--;
            }
            break;
          case "\t":
            console.log("TODO: nextstop");
            break;
          case "\x0e":
            set_gx_level(1);
            break;
          case "\x0f":
            set_gx_level(0);
            break;
          case "\x1b":
            // nalezen ESC
            state = State.escaped;
            break;
          default:
            if (ch >= " ") {
              // prevod znaku do zvolene znakove sady
              if ((ref = charset) != null ? ref[ch] : void 0) {
                ch = charset[ch];
              }

              // prechod na novy radek pokud jsme na konci
              if (buf.x >= cols) {
                if (autowrap_mode) {
                  next_line(buf);
                  buf.x = 0;
                } else {
                  buf.x = cols - 1;
                }
              }

              // vlozeni znaku
              if (insert_mode) {
                buf.lines[buf.shift + buf.y].chars.push(buf.x, 0, {char : ch, attr : attr});
                buf.lines[buf.shift + buf.y].chars.pop();
              } else {
                buf.lines[buf.shift + buf.y].chars[buf.x].char = ch;
                buf.lines[buf.shift + buf.y].chars[buf.x++].attr = attr;
              }
            } else {
              console.log("TODO: handle char " + ch);
            }
            break;
        }
        break;
      case State.escaped:
        switch (ch) {
          case "[":
            // functions using CSI
            params = [];
            param = 0;
            prefix = "";
            state = State.csi;
            break;
          case "]":
            // operating system commands
            params = [];
            param = 0;
            prefix = "";
            state = State.osc;
            break;
          case "P":
            // device control functions
            params = [];
            param = 0;
            prefix = "";
            state = State.dcs;
            break;
          case "_":
          case "^":
            state = State.ignore;
            break;
          case "c":
            console.log("TODO full reset");
            break;
          case "D":
            index(buf);
            state = State.normal;
            break;
          case "E":
            buf.x = 0;
            next_line(buf);
            break;
          case "M":
            reverse_index(buf);
            state = State.normal;
            break;
          case "%":
            set_gx_level(0);
            set_gx_charset(0, charset_table.united_states);
            state = State.normal;
            i++;
            break;
          case "7":
            save_cursor(buf);
            state = State.normal;
            break;
          case "8":
            restore_cursor(buf);
            state = State.normal;
            break;
          case "(":
          case ")":
          case "*":
          case "+":
          case "-":
          case ".":
            switch (ch) {
              case "(":
                g_charset = 0;
                break;
              case ")":
              case "-":
                g_charset = 1;
                break;
              case "*":
              case ".":
                g_charset = 2;
                break;
              case "+":
                g_charset = 3;
            }
            state = State.charset;
            break;
          case "/":
            g_charset = 3;
            state = State.charset;
            i--;
          case "n":
            set_gx_level(2);
            break;
          case "o":
            set_gx_level(3);
            break;
          case "|":
            set_gx_level(3);
            break;
          case "}":
            set_gx_level(3);
            break;
          case "~":
            set_gx_level(1);
            break;
          case "H":
            console.log("TODO tab set");
            break;
          case "=":
            application_keypad = true;
            state = State.normal;
            break;
          case ">":
            application_keypad = false;
            state = State.normal;
            break;
          default:
            state = State.normal;
            console.log("Unknown ESC control:", ch);
        }
        break;
      case State.charset:
        // volba znakove sady
        switch (ch) {
          case "0":
            new_charset = charset_table.spec_char_and_line_draw;
            break;
          case "A":
            new_charset = charset_table.united_kingdom;
            break;
          case "B":
            new_charset = charset_table.united_states;
            break;
          case "4":
            new_charset = charset_table.dutch;
            break;
          case "5":
          case "C":
            new_charset = charset_table.finnish;
            break;
          case "f":
          case "R":
            new_charset = charset_table.french;
            break;
          case "9":
          case "Q":
            new_charset = charset_table.french_canadian;
            break;
          case "K":
            new_charset = charset_table.german;
            break;
          case "Y":
            new_charset = charset_table.italian;
            break;
          case "6":
          case "E":
            new_charset = charset_table.norwegian_danish;
            break;
          case "Z":
            new_charset = charset_table.spanish;
            break;
          case "7":
          case "H":
            new_charset = charset_table.swedish;
            break;
          case "=":
            new_charset = charset_table.swiss;
            break;
          case "/":
            new_charset = charset_table.iso_latin;
            i++;
            break;
          default:
            new_charset = charset_table.united_states;
        }
        set_gx_charset(g_charset, new_charset);
        g_charset = null;
        state = State.normal;
        break;
      case State.csi:
        // funkce s Control Sequence Introducer
        if (ch == "?" || ch == ">" || ch == "!") {
          prefix = ch;
          break;
        }

        if (ch >= "0" && ch <= "9") {
          param = param * 10 + ch.charCodeAt(0) - 48;
          break;
        }

        if (ch == "$" || ch == "\"" || ch == " " || ch == "'") {
          break;
        }

        if (ch <= " " || ch >= "~") {
          if (ch == '\b') {
            param = (param / 10) & 1;
          }
          if (ch == '\r') {
            buf.x = 0;
          }
          if (["\n", "\x0b", "\x0c"].indexOf(ch) >= 0) {
            next_line(buf);
          }
          break;
        }

        params.push(param);
        param = 0;

        if (ch == ";") {
          break;
        }

        state = State.normal;
        switch (ch) {
          case "A":
            cursor_up(buf, params);
            break;
          case "B":
            cursor_down(buf, params);
            break;
          case "C":
            cursor_forward(buf, params);
            break;
          case "D":
            cursor_backward(buf, params);
            break;
          case "G":
            cursor_char_absolute(buf, params);
            break;
          case "H":
            cursor_pos(buf, params);
            break;
          case "J":
            erase_in_display(buf, params);
            break;
          case "K":
            erase_in_line(buf, params);
            break;
          case "L":
            insert_line(buf, params);
            break;
          case "M":
            delete_line(buf, params);
            break;
          case "P":
            delete_character(buf, params);
            break;
          case "T":
            if (params.length < 2 && prefix.length == 0) {
              scroll_down(params);
            }
            break;
          case "X":
            erase_chars(buf, params);
            break;
          case "c":
            send_device_attributes(prefix, params);
            break;
          case "d":
            line_pos_absolute(buf, params);
            break;
          case "h":
            set_mode(prefix, params);
            break;
          case "l":
            reset_mode(prefix, params);
            break;
          case "m":
            if (prefix.length == 0) {
              char_attributes(params);
            }
            break;
          case "n":
            device_status(buf, prefix, params);
            break;
          case "r":
            set_scroll_region(buf, prefix, params);
            break;
          case "s":
            save_cursor(buf, params);
            break;
          case "u":
            restore_cursor(buf, params);
            break;
          default:
            console.log("TODO handle csi code " + ch + " params " + params);
            break;
        }
        prefix = "";
        break;
      case State.osc:
        // operating system commands
          if (ch == "\x1b" || ch == "\x07") {
            if (ch == "\x1b") {
              i++;
            }
            params.push(param);
            switch (params[0]) {
              case 0:
              case 1:
              case 2:
                if (params[1]) {
                  var title = params[1];
                  set_title(title);
                }
                break;
            }
            params = [];
            param = 0;
            state = State.normal;
          } else {
            if (!params.length) {
              if (ch >= "0" && ch <= "9") {
                param = param * 10 + ch.charCodeAt(0) - 48;
              } else if (ch === ";") {
                params.push(param);
                param = "";
              }
            } else {
              param += ch;
            }
          }
        break;

      case State.dcs:
        // device control functions
        if (ch == "\x1b" || ch == "\x07") {
          if (ch == "\x1b") {
            i++;
          }
          console.log("TODO handle dcs code");

          param = 0;
          prefix = "";
          state = State.normal;
        } else if (!param) {
          if (!prefix && ch !== "$" && ch !== "+") {
            param = ch;
          } else if (prefix.length == 2) {
            param = ch;
          } else {
            prefix += ch;
          }
        } else {
          param += ch;
        }
        break;

      case State.ignore:
        console.log("State.ignore");
        if (ch == "\x1b" || "\x07") {
          if (ch == "\x1b") {
            i++;
          }
          state = State.normal;
        }
        break;
    }
    i++;
  }
  // prekresleni okna
  refresh_screen();
  // posun na aktualni okno
  scroll_display();
}

// zjisteni velikosti jednoho znaku
function get_char_size()
{
  var test_div = document.createElement('div');
  var screen = document.getElementById("screen");

  // testovaci radek
  test_div.className = "divTableRow";
  screen.appendChild(test_div);

  // vlozeni zkusebniho textu
  var test_span = document.createElement('span');
  test_span.textContent = "0123456789";
  test_div.appendChild(test_span);

  // zjisteni delky a vysky radku
  var span_dim = test_span.getBoundingClientRect();
  var div_dim = test_div.getBoundingClientRect();

  // zahozeni testovacich prvku
  screen.removeChild(test_div);

  // rozmery jednoho znaku
  return {
    width: span_dim.width / 10,
    height: div_dim.height
  }
}

// zabraneni provedeni vychozi akce klaves
storno_event = function(event)
{
  if (event.preventDefault) {
    event.preventDefault();
  }
  if (event.stopPropagation) {
    event.stopPropagation();
  }
  event.cancelBubble = true;
}

// nastaveni obsluhy vstupu od uzivatele
function set_hmi_callbacks() {
  // obsluha keydown
  document.addEventListener('keydown', function(event) {
    var key;

    if (event.keyCode > 15 && event.keyCode < 19) {
      return true;
    }
    if ((event.shiftKey || event.ctrlKey) && event.keyCode == 45) {
      return true;
    }
    if ((event.shiftKey && event.ctrlKey) && ((event.keyCode) == 67 || event.keyCode == 86)) {
      return true;
    }
    switch (event.keyCode) {
      case 8:
        key = event.altKey ? "\x1b" : "";
        if (event.shiftKey) {
          key += "\x08";
          break;
        }
        key += "\x7f";
        break;
      case 9:
        if (event.shiftKey) {
          key = "\x1b[Z";
          break;
        }
        key = "\t";
        break;
      case 13:
        key = "\r";
        break;
      case 27:
        key = "\x1b";
        break;
      case 33:
        if (event.shiftKey) {
          if (event.ctrlKey) {
            break;
          }
          scroll_display(-rows);
          storno_event(event);
        } else {
          key = "\x1b[5~";
        }
        break;
      case 34:
        if (event.shiftKey) {
          if (event.ctrlKey) {
            break;
          }
          scroll_display(rows);
          storno_event(event);
        } else {
          key = "\x1b[6~";
        }
        break;
      case 35:
        if (application_keypad) {
          key = "\x1bOF";
          break;
        }
        key = "\x1b[F";
        break;
      case 36:
        if (application_keypad) {
          key = "\x1bOH";
          break;
        }
        key = "\x1b[H";
        break;
      case 37:
        if (application_cursor) {
          key = "\x1bOD";
          break;
        }
        key = "\x1b[D";
        break;
      case 38:
        if (application_cursor) {
          key = "\x1bOA";
          break;
        }
        if (event.shiftKey) {
          scroll_display(-1);
          storno_event(event);
        } else {
          key = "\x1b[A";
        }
        break;
      case 39:
        if (application_cursor) {
          key = "\x1bOC";
          break;
        }
        key = "\x1b[C";
        break;
      case 40:
        if (application_cursor) {
          key = "\x1bOB";
          break;
        }
        if (event.shiftKey) {
          scroll_display(1);
          storno_event(event);
        } else {
          key = "\x1b[B";
        }
        break;
      case 46:
        key = "\x1b[3~";
        break;
      case 45:
        key = "\x1b[2~";
        break;
      case 112:
        key = "\u001bOP";
        break;
      case 113:
        key = "\u001bOQ";
        break;
      case 114:
        key = "\u001bOR";
        break;
      case 115:
        key = "\u001bOS";
        break;
      case 116:
        key = "\u001b[15~";
        break;
      case 117:
        key = "\u001b[17~";
        break;
      case 118:
        key = "\u001b[18~";
        break;
      case 119:
        key = "\u001b[19~";
        break;
      case 120:
        key = "\u001b[20~";
        break;
      case 121:
        key = "\u001b[21~";
        break;
      case 122:
        key = "\u001b[23~";
        break;
      case 123:
        key = "\u001b[24~";
        break;
      default:
        if (event.ctrlKey) {
          if (event.keyCode >= 65 && event.keyCode <= 90) {
            key = String.fromCharCode(event.keyCode - 64);
          } else if (event.keyCode === 32) {
            key = String.fromCharCode(0);
          } else if (event.keyCode >= 51 && event.keyCode <= 55) {
            key = String.fromCharCode(event.keyCode - 51 + 27);
          } else if (event.keyCode === 56) {
            key = String.fromCharCode(127);
          } else if (event.keyCode === 219) {
            key = String.fromCharCode(27);
          } else {
            if (event.keyCode === 221) {
              key = String.fromCharCode(29);
            }
          }
        } else if ((event.altKey && navigator.platform != 'Mac') || (event.metaKey && navigator.platform == 'Mac')) {
          console.log("alt + " + event.keyCode);
          if (event.keyCode >= 65 && event.keyCode <= 90) {
            key = "\x1b" + String.fromCharCode(event.keyCode + 32);
          } else if (event.keyCode == 192) {
            key = "\x1b`";
          } else {
            if (event.keyCode >= 48 && event.keyCode <= 57) {
              key = "\x1b" + (event.keyCode - 48);
            }
          }
        }
    }
    if (event.keyCode >= 37 && event.keyCode <= 40) {
      if (event.ctrlKey) {
        key = key.slice(0, -1) + "1;5" + key.slice(-1);
      } else if (event.altKey) {
        key = key.slice(0, -1) + "1;3" + key.slice(-1);
      } else if (event.shiftKey) {
        key = key.slice(0, -1) + "1;4" + key.slice(-1);
      }
    }

    if (!key) {
      return;
    }
    send_cmd("wterm", key);
    storno_event(event);
  });
  // obsluha keypress
  document.addEventListener('keypress', function(event) {
    var key, ref;
    if (event.keyCode > 15 && event.keyCode < 19) {
      return true;
    }
    if ((event.shiftKey || event.ctrlKey) && event.keyCode == 45) {
      return true;
    }
    if ((event.shiftKey && event.ctrlKey) && ((event.keyCode) == 67 || event.keyCode == 86)) {
      return true;
    }
    storno_event(event);
    if (event.charCode) {
      key = event.charCode;
    } else if (event.which == null) {
      key = event.keyCode;
    } else if (event.which !== 0 && event.charCode !== 0) {
      key = event.which;
    } else {
      return;
    }
    if (!key || event.ctrlKey || event.altKey || event.metaKey) {
      return false;
    }
    if (event.which >= 32 && event.which <= 127) {
      key = String.fromCharCode(key);
      send_cmd("wterm", key);
    }
  });
  // obsluha paste
  div_wrapper.addEventListener('paste', function(event) {
    clipboardData = event.clipboardData || window.clipboardData;
    pastedData = clipboardData.getData('Text');
    send_cmd("wterm", pastedData);
    storno_event(event);
  });
}

// spusteni terminalu
function terminal_start(_user)
{
  // handle bunky, kde bude terminal
  var screen = document.getElementById("screen");

  // predani uzivatele
  user = _user;

  // zjisteni velikosti jednoho znaku
  char_size = get_char_size();

  // vypocet velikosti okna
  cols = Math.floor(((window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth) - 250 - 20) / char_size.width);
  rows = Math.floor(((window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight) - 120) / char_size.height);

  // inicializace screenu
  buf_init(std_buf);
  buf_init(alt_buf);

  // spusteni posilaciho "vlakna"
  poll_requests();

  // vynuceni refreshe "GUI" aplikaci umelou zmenou velikosti okna
  send_cmd("wsize", (cols-1) + "," + (rows-1));
  // preposlani realne velikosti okna do terminalu
  send_cmd("wsize", cols + "," + rows);

  // vychozi okraje
  top_margin = 0;
  bottom_margin = rows - 1;

  // vytvoreni obalovaciho DIVu s posuvnikem
  div_wrapper = document.createElement('div');
  div_wrapper.style.width = cols * char_size.width + 20;
  div_wrapper.style.height = rows * char_size.height;
  div_wrapper.id = "screen_wrapper";
  div_wrapper.className = "divWrapper";
  div_wrapper.contentEditable = true;
  div_wrapper.spellcheck = false;
  screen.appendChild(div_wrapper);
  div_wrapper.appendChild(buf.screen);

  // nastaveni vychozich atributu
  attr = get_default_attr();

  // nastartovani terminalu
  send_cmd("wterm", "");

  // nastaveni obsluhy klaves
  set_hmi_callbacks();
}
